unit display;

interface

procedure printSun;
procedure printStat;
procedure printACC1;
procedure printACC2;
procedure printShortStat;

procedure iprintSun;
procedure iprintStat;
procedure iprintACC1;
procedure iprintACC2;
procedure iprintShortStat;

implementation

uses sun,crt,engine;

procedure iprintSun;
var
  j,n:byte;
begin
  window(1,1,80,6);
  writeln('   Time:______________');
  writeln('Temperature___________');
  writeln('Cloudy days___________');
  writeln('Direct intensity:_____');
  writeln('Difusion intensity:___');
    write('Power Intensity:______');
  window(1,1,80,25);
end;

procedure iprintStat;
begin
  window(1,7,50,16);
  writeln('Total energy:_________');
  writeln('Energy per hour:______');
  writeln('Left days:____________');
  writeln('System efficiency:____');
  writeln('System Losses:________');
  writeln('External Power:_______');
  writeln('Used Energy:__________');
  writeln('Wasted E in collectors:');
  writeln('Current MODE:');
  window(1,1,80,25);
end;

procedure iprintShortStat;
begin
  window(1,7,50,16);
  writeln('Left days:____________');
  writeln('External Power:_______');
  writeln('Used Energy:__________');
  window(1,1,80,25);
end;


procedure iprintACC1;
begin
  window(1,16,50,24);
  writeln('ACC1 Status:');
{  writeln('Tank Volume:');
  writeln('ThresholdTemp:');}
  writeln('Medium Temp.:');
  writeln('Stored Energy:');
  writeln('Power Losses:');
  writeln('Lost Energy:');
  writeln('Used Energy:');
  writeln('C1:');
  writeln('dT/dt:');
  window(1,1,80,24);
end;

procedure iprintACC2;
begin
  window(35,16,80,24);
  writeln('ACC2 Status:');
{  writeln('Tank Volume:');
  writeln('ThresholdTemp');}
  writeln('Medium Temp.:');
  writeln('Stored Energy:');
  writeln('Power Losses:');
  writeln('Lost Energy:');
  writeln('Used Energy:');
  writeln('F2:');
  writeln('dT/dt:');
  window(1,1,80,25);
end;

procedure printSun;
var
  j,n:byte;
begin
  window(25,1,80,6);
  writeln(hour:2:1,' hr  ',day,'  day of  ',month,'  ');
  writeln(Ta:2:1,' C  ');
  writeln(CloudyDays);
  writeln(IP:4:2,' W/m^2   ');
  writeln(ID:4:2,' W/m^2   ');
  write(I:4:2,' W/m^2   ');

  n:= trunc(I) div 100;
  for j:=1 to n do write('>');
  for j:=1 to 5 do write(' ');

  window(1,1,80,25);
end;

procedure printStat;
begin
  window(25,7,70,16);
  writeln(TEQ:5:3,' kWh ');
  writeln(HRE:5:3,' kWh ');
  writeln(LD,' ');
  if TEQ>0 then
  writeln((((ACC1+ACC2-EXP+USER)/TEQ)*100):2:1,' %');
  writeln((PZ*colar+ACCLOSS1+ACCLOSS2):3:2,' W  ');
  if USER>0 then
  writeln(EXP:5:2,' kWh = ',(100*EXP/USER):2:1,' % of Used E');
  writeln(USER:5:2,' kWh ');
  writeln(COLOST:5:1,' kWh ',' ColEfficiency:',HrEff);
  writeln(MODE);
  window(1,1,80,25);
end;

procedure printShortStat;
begin
  window(25,7,70,16);
  writeln(LD,' ');
  if USER>0 then
  writeln(EXP:5:2,' kWh = ',(100*EXP/USER):2:1,' % of Used E');
  writeln(USER:5:2,' kWh ');
  window(1,1,80,25);
end;


procedure printACC1;
begin
  window(16,16,50,24);
  writeln(V1:4:1,' litres');
{  writeln(TT1:2:1,' C ');}
  writeln((T1+dT1):2:1,' C ');
  writeln(ACC1:4:3,' kWh   ');
  writeln(ACCLOSS1:3:1,' W ');
  writeln(LOST1:3:1, ' kWh ');
  writeln(UACC1:3:1, ' kWh ');
  writeln(C1:1:5);
  writeln(dT1_dt:2:5,' =',(getQJ(V1,dT1_dt)/60):4:1,' W');

  window(1,1,80,25);
end;

procedure printACC2;
begin
  window(54,16,80,24);
  writeln(V2:4:1,' litres');
{  writeln(TT2:2:1,' C ');}
  writeln((T2+dT2):2:1,' C ');
  writeln(ACC2:4:3,' kWh  ');
  writeln(ACCLOSS2:3:1, ' W ');
  writeln(LOST2:3:1, ' kWh ');
  writeln(UACC2:3:1, ' kWh ');
  writeln(F2:1:5);
  writeln(dT2_dt:2:5,' =',(getQJ(V2,dT2_dt)/60):4:1,' W');
  window(1,1,80,25);
end;



end.