unit ENGINE;
{ simulacni SW pro projekt PES }
interface

uses Sun,display, crt,math;

procedure run;
function getDT(v,e:real):real;
procedure getWater(t,V:real);
procedure updateTa;
function getQ(v,dT:real):real;
function getQJ(v,dT:real):real;
procedure loadDef;
procedure loadWater;
procedure updateCloudy;

type
  TWaterDemand= record
                  Qty,Temp:real;
                end;
var
  ACC1,ACC2: real; { akumulovana energie }
  TT1,TT2: real; { theshold temperature }
  V1,V2: real; { volume of accumulator }
  S1,S2:real;  { plocha nadrzi }
  dT1,dT2: real;   { +temp }
  T1,T2: real; { start temp }
  TEQ: real; { total energy [kWh] per sq meter }
  HRE: real; { energy per 1 hour }
  LD: word; { left days }
  colar:real; { collector area }
  CPDQM: real; { Collector Power Disipation per Sq meter/K }
  XCHGdT: real;  { Exchanger dT [C] }
  Ta: real; { ambient temp }
  PZ: real; { power looses }
  ACCLOSS1,ACCLOSS2: real;
  ACCTempCond: real; { ACC insulation material conductivity W/K/m^2 }
  iL1,iL2: real; { insulation mass - length }
  EXP:real; { external power }
  USER: real; { delivered energy }
  LOST1,LOST2:real;
  UACC1,UACC2:real;
  COLOST: real;
  WaterDemand:array[0..23] of TWaterDemand;
  dT1_dt,dT2_dt:real;
  C1,F2: real;
  dHEAT_A1,dHEAT_A2:real;
  dC1,dF2: real;
  minF2:real;
  MODE:byte;
  HYST: real;
  HrEff: integer;
  TCW: real;

  fo:text;


implementation


uses inifile;


procedure run;
label X2A;
var
  j: byte;
  ch: char;
begin
  day:=1;
  month:=6;
  hour:=1;
  clrscr;
{  iprintSun;
  iprintStat;
  iprintAcc1;
  iprintAcc2;
  iprintShortStat;}

  writeln('Computing One Year:');

  geoWidth:=50;
  sklon:=90;
  azimut:=0;
  H:=300;
  Z:=3;
  albedo:=0.2;
{  cloudy:=50; { percent cloudy days }

  colar:=4; { m^2 }


  LD:=0; ACC1:=0; ACC2:=0;
  PZ:=0;
  ACCLOSS1:=0;ACCLOSS2:=0;
  USER:=0;
  LOST1:=0; LOST2:=0;
  COLOST:=0;
  UACC1:=0; UACC2:=0;
  { ====== USER ========= }

  TT1:= 75;
  TT2:= 40;
  T1:= 10; dT1:=0;
  T2:= 10; dT2:=0;
  V1:= 200;
  V2:= 700;

  TEQ:=0;
  CPDQM:= 1.1; { W/K/m^2 }
  XCHGdT:= 3;
  Ta:= 20;
  S1:= 2.7; iL1:=0.35; { [m] }
  S2:= 4.5;iL2:=0.40; { [m] }
  ACCTempCond:=0.025;

  C1:=0.06;
  F2:=0.04;
  dHEAT_A1:=0;dHEAT_A2:=0;
  dC1:=0.0001;    { pro maly 200,600litru nejlepsi 0.00001}
  dF2:=0.0002;
  minF2:=0.0001;
  MODE:=1;
  HYST:=5; { [C] }
  TCW:=10; { [C] }

  loadDef;
  loadWater;
  assign(fo,'result.dat');
  {$I-}
  rewrite(fo);
  if IOresult<>0 then halt(1);
  {$I+}
  writeln(fo,'m  day hr  I   MODE  HrEff');
  {============}
  repeat
    updateTa;
    updateCloudy;

    {=======odberatel==========}
    dT1:= getDT(V1,ACC1);
    dT2:= getDT(V2,ACC2);
    if WaterDemand[round(hour)].Qty>0 then begin
      getWater(WaterDemand[round(hour)].Temp,WaterDemand[round(hour)].Qty);
    end;
    {=======odberatel==========}



    {========SUN===========}
    { aproximuj 1 hodinu po 0.1hodine }
    HRE:=0;

    for j:=1 to 10 do begin
      hour:= hour+0.1;
      sunSim;
      HRE:= (((I-PZ)/10000)*colar);
      TEQ:= TEQ + ((I/10000)*colar);

      { ---- sophisticated control ----- }
      { rozdeleni energie podle pripojenych accu }
      dHEAT_A1:=0;
      dHEAT_A2:=0;
      case MODE of
        1: dHEAT_A1:=HRE;
        2: dHEAT_A2:=HRE;
      end;


      { jednotlive algoritmy dle modu }
      {gotoxy(79,1);
      write(MODE);}
      HrEff:= 0;
      { aktivuje se pri 0% ucinnosti a v dne (I) }
      if (HRE>=0) and (I>0) then begin
       { kolektory }
        COLOST:= COLOST + (PZ/10000)*colar;

       case MODE of
        1: begin
             ACC1:=ACC1+dHEAT_A1;
             dT1:= getDT(V1,ACC1);
             dT1_dt:= (getDT(V1,dHEAT_A1))/6; { x C/minutu }
             if dT1_dt>C1 then begin
               if (T1+dT1)>TT1 then begin
                 if (dT2+T2)<(dT1+T1+HYST) then begin
                   C1:= C1 + dC1;
                   F2:= F2+dF2;
                   MODE:=2;
                 end;
               end;
             end
             else begin
               if (dT2+T2)<(dT1+T1+HYST) then begin
                 C1:= C1 - dC1;
                 MODE:=2; { accu 2 }
               end;
             end;

           end;
        2: begin
             ACC2:=ACC2+dHEAT_A2;
             dT2:= getDT(V2,ACC2);
             dT2_dt:= (getDT(V2,dHEAT_A2))/6; { x C/minutu }
             if (T1+dT1)<TT1 then begin
               F2:= F2-dF2;
               if F2<minF2 then F2:=minF2;
             end;
             if dT2_dt>F2 then begin
               F2:= F2+dF2;
               if (dT1+T1)<TT1 then begin
                 MODE:=1;
               end
               else begin
                 X2A:
                 if (dT2+T2+HYST)<(dT1+T1) then
                   MODE:=2
                 else
                   MODE:=1;
               end;
             end
             else begin
               if (dT2+T2)>TT2 then goto X2A;
             end;

           end;
        3: begin
             if (dT1+T1)<TT1 then MODE:=1;
             if (dT2+T2)<TT2 then MODE:=2;
             ACC1:=ACC1+dHEAT_A1;
             dT1:= getDT(V1,ACC1);
             ACC2:=ACC2+dHEAT_A2;
             dT2:= getDT(V2,ACC2);
           end;
        end;
        { ucinnost kolektoru }
        if I>0 then
          if j=1 then HrEff:= (trunc((I-PZ)/I)*100) else HrEff:= (HrEff + trunc(100*((I-PZ)/I))) div 2;
        {=======ACCUMULATORS========}
        case MODE of
          1: PZ:= (T1+dT1+XCHGdT-Ta)*CPDQM;
          2: PZ:= (T2+dT2+XCHGdT-Ta)*CPDQM;
        end;
        if HRE<=0 then PZ:=0;
     end;
    end;

    { =========Accu loss====== }
    { 1st Tank }
    ACCLOSS1:= (S1/iL1)*ACCTempCond*(T1+dT1-Ta);
    ACC1:= ACC1 - (ACCLOSS1/1000);
    dT1:= getDT(V1,ACC1);
    if (dT1+T1)>99 then begin
      ACC1:=getQ(V1,99-T1);
      dT1:= getDT(V1,ACC1);
    end;

    LOST1:= LOST1 + (ACCLOSS1/1000);
    { 2nd Tank }
    ACCLOSS2:= ((S2/iL2)*ACCTempCond)*(T2+dT2-Ta);
    ACC2:= ACC2 - (ACCLOSS2/1000);
    dT2:= getDT(V2,ACC2);
    if (dT2+T2)>99 then begin
      ACC2:=getQ(V2,99-T2);
      dT2:= getDT(V2,ACC2);
    end;
    LOST2:= LOST2 + (ACCLOSS2/1000);

    dT1:= getDT(V1,ACC1);
    dT2:= getDT(V2,ACC2);
    {=========================}

    if hour>=24 then begin
      inc(day);
      inc(LD);
      hour:=0;
      write('.');
    end;
    if day>=31 then begin
      inc(month);
      day:=1;
    end;
    if month>12 then begin
      month:=1;
    end;


    {========SUN===========}


    {printSun;
    printShortStat;
    {printAcc1;
    printAcc2;}

    {====OUTPUT===}
writeln(fo,month,' ',day,' ',hour:2:0,' ',I:3:0,'   ',MODE,' T1: ',(dT1+T1):2:1,' T2: ',(dT2+T2):2:1,' e:',HrEff);

{   delay(20);}
    if keypressed then begin
      iprintSun;
      iprintStat;
      iprintAcc1;
      iprintAcc2;
      printSun;
      printAcc1;
      printAcc2;
      printStat;
      ch:=readkey;
      repeat until keypressed;
      ch:=readkey;
      clrscr;
    end;

    if ((LD mod 365)=0) and (LD<>0) and (hour=0) then begin
      clrscr;
      iprintSun;
      iprintStat;
      iprintAcc1;
      iprintAcc2;
      printSun;
      printAcc1;
      printAcc2;
      printStat;
      writeln('******** NEW YEAR *********');
      repeat until keypressed;
      clrscr;
      writeln('Computing One Year Including Last Years:');
      ch:=readkey;
      {EXP:=0;}
    end;
  until ch='q';
  close(fo);
end;

function getDT(v,e:real):real;
begin
  getDT:= (e*3600000)/(4180*v); { litry! }
end;

function getQ(v,dT:real):real;
begin
  getQ:= (4180*v*dT)/3600000;
end;

function getQJ(v,dT:real):real;
begin
  getQJ:= (4180*v*dT);
end;


procedure getWater(t,V:real);
var
  dQ,THW:real;
  n,j:word;
  m1,m2: real; { mnozstvi jednotlivych vod o T1, T2 - pro michani }
  { m1 vzdy teplejsi nez m2 }
  { dle vzroce m1=(T0-T)/(T0-T1)*m
        kde T0 je nejstudenejsi voda
            T1 tepla voda
            T  pozadovana teplota
                                  }
  xT0,xT1,xT2:real;

begin
  n:=round(V);
  xT0:= TCW;
  xT1:= dT2+T2-XCHGdT;
  xT2:= dT1+T1-XCHGdT;

  for j:=1 to n do begin
    { michani TCW + T1 }
    if t<=xT1 then begin
      m1:=(xT0-t)/(xT0-xT1); { m = 1kg }
      m2:= 1-m1;
      dQ:=getQ(m1,dT2-XCHGdT);
      ACC2:= ACC2-dQ;
      UACC2:= UACC2+dQ;
      USER:=USER+dQ;
    end else begin
      { michani T2+T1 }
      if t<=xT2 then begin
        m1:=(xT0-t)/(xT0-xT2); { m = 1kg }
        m2:= 1-m1;
        { energie z teplejsiho zasobniku }
        dQ:= getQ(m1,dT1-dT2-XCHGdT);
        ACC1:= ACC1-dQ;
        UACC1:= UACC1+dQ;
        USER:=USER+dQ;
        { energie ze studenejsiho pro predehrati tepeljsiho accu  }
        dQ:=getQ(m1,dT2-XCHGdT);
        ACC2:= ACC2-dQ;
        UACC2:= UACC2+dQ;
        USER:=USER+dQ;
        { energie ze studenejsiho pro michani }
        dQ:=getQ(m2,dT2-XCHGdT);
        ACC2:= ACC2-dQ;
        UACC2:= UACC2+dQ;
        USER:=USER+dQ;
      end else begin
        { michani T2+dohrev }
        if t>xT2 then begin
          { 1kg proleze vsemi zasobniky, zadne michani }
          { energie z ohrivaku na tepltotu t }
          dQ:= getQ(1,t-xT0-(dT1-XCHGdT));
          EXP:=EXP+dQ; { externi energie }
          USER:=USER+dQ;
          { energie z teplejsiho zasobniku }
          dQ:= getQ(1,dT1-dT2-XCHGdT);
          ACC1:= ACC1-dQ;
          UACC1:= UACC1+dQ;
          USER:=USER+dQ;
          { energie ze studenejsiho accu }
          dQ:=getQ(1,dT2-XCHGdT);
          ACC2:= ACC2-dQ;
          UACC2:= UACC2+dQ;
          USER:=USER+dQ;
        end;
      end;
    end;
    dT1:= getDT(V1,ACC1);
    dT2:= getDT(V2,ACC2);
  end;
end;

procedure updateTa;
var
  tau:real;
  dT,Tav:real;
begin
  tau:= rad((hour-12)*15);
  case month of { praha }
    1 :Tav:= -1.5;
    2 :Tav:= 0;
    3 :Tav:= 3.2;
    4 :Tav:= 8.8;
    5 :Tav:= 13.6;
    6 :Tav:= 17.3;
    7 :Tav:= 19.2;
    8 :Tav:= 18.6;
    9 :Tav:= 14.9;
    10:Tav:= 9.4;
    11:Tav:= 3.2;
    12:Tav:= -0.2;
  end;
  case month of { praha }
    1 :dT:= 5;
    2 :dT:= 5;
    3 :dT:= 5.5;
    4 :dT:= 6.5;
    5 :dT:= 7.5;
    6 :dT:= 8;
    7 :dT:= 8;
    8 :dT:= 8;
    9 :dT:= 7.5;
    10:dT:= 6.5;
    11:dT:= 5.5;
    12:dT:= 5;
  end;
  Ta:= Tav + (dT*cos(tau-(Pi/6)));
end;

procedure updateCloudy;
begin
  case month of { praha }
    1 :cloudy:= 79;
    2 :cloudy:= 68;
    3 :cloudy:= 58;
    4 :cloudy:= 55;
    5 :cloudy:= 49;
    6 :cloudy:= 46;
    7 :cloudy:= 45;
    8 :cloudy:= 45;
    9 :cloudy:= 47;
    10:cloudy:= 63;
    11:cloudy:= 79;
    12:cloudy:= 86;
  end;
end;


procedure loadDef;
var
   f:text;
   param:string;
begin
  assign(f,'system.inf');
  {$I-}
  reset(f);
  if IOResult<>0 then  begin
    writeln('file system.inf not found.');
    halt(1);
  end;
  {$I+}
  while not eof(f) do begin
    readln(f,param);
    cmd(param);
    case c of
      _day:     day:= xint[0];
      _month:   month:= xint[0];
      _hour:    hour:= xreal[0];
      _geoWidth:geoWidth:= xint[0];
      _sklon:   sklon:=xreal[0];
      _azimut:  azimut:=xreal[0];
      _nadmVyska:H:=xreal[0];
      _Z:        Z:=xint[0];
      _albedo:   albedo:=xreal[0];
      _SunConst: Io:=xreal[0];
      _cloudy:   clouds:=xint[0];
      _LD:       LD:= xint[0];
      _ACC1:     ACC1:=xreal[0];
      _ACC2:     ACC2:=xreal[0];
      _USER:     USER:=xreal[0];
      _LOST1:    LOST1:=xreal[0];
      _LOST2:    LOST2:=xreal[0];
      _COLOST:   COLOST:=xreal[0];
      _UACC1:    UACC1:=xreal[0];
      _UACC2:    UACC2:=xreal[0];
      _TT1:      TT1:=xreal[0];
      _TT2:      TT2:=xreal[0];
      _T1:        T1:=xreal[0];
      _dT1:      dT1:=xreal[0];
      _T2:       T2:=xreal[0];
      _dT2:      dT2:=xreal[0];
      _V1:       V1:=xreal[0];
      _V2:       V2:=xreal[0];
      _TEQ:      TEQ:=xreal[0];
      _CPDQM:    CPDQM:=xreal[0];
      _XCHGdT:   XCHGdT:=xreal[0];
      _S1:       S1:=xreal[0];
      _iL1:      iL1:=xreal[0];
      _S2:       S2:=xreal[0];
      _iL2:      iL2:=xreal[0];
      _ACCTempCond:ACCTempCond:=xreal[0];
      _colar:    colar:=xreal[0];
    end;
  end;
  close(f);
end;

procedure loadWater;
var
   f:text;
   param:string;
   x:real;
   err:integer;
   j:byte;
begin
  assign(f,'water.inf');
  {$I-}
  reset(f);
  if IOResult<>0 then  begin
    writeln('file water.inf not found.');
    halt(1);
  end;
  {$I+}
  for j:=0 to 23 do begin
    if eof(f) then exit;
    readln(f,param);
    cmdStr:=param;
    odmazMezirky(cmdStr);
    cutIt;
    val(cmdCont[0],x,err);
    if err<>0 then writeln('water.inf error @line:',j+1);
    waterDemand[j].Qty:=x;
    val(cmdCont[1],x,err);
    if err<>0 then writeln('water.inf error @line:',j+1);
    waterDemand[j].Temp:=x;
  end;
{  close(f);}
end;


end.

if t<=(T2+dT2+XCHGdT) then begin
     dQ:= getQ(t-T2,1);
     ACC2:= ACC2 - dQ;
     UACC2:= UACC2 + dQ; { used energy }
     USER:= USER+dQ;
   end else begin
   if t<=(T1+dT1+XCHGdT) then begin
    { voda proleze 2. zasobik s vlaznou vodou }
    dQ:= getQ(dT2-XCHGdT,1);
    ACC2:= ACC2 - dQ;
    UACC2:= UACC2 + dQ;
    USER:= USER+dQ;
    { proleze 1. s teplou }
    dQ:= getQ(t-T1-(dT2-XCHGdT),1);
    ACC1:= ACC1 - dQ;
    UACC1:= UACC1 + dQ;
    USER:= USER+dQ;
    end else begin
      { voda proleze 2. zasobik s vlaznou vodou }
      dQ:= getQ(dT2-XCHGdT,1);
      ACC2:= ACC2 - dQ;
      UACC2:= UACC2 + dQ;
      USER:= USER+dQ;
      { proleze 1. s teplou }
      dQ:= getQ(dT1-dT2-XCHGdT,1);
      ACC1:= ACC1 - dQ;
      UACC1:= UACC1 + dQ;
      USER:= USER+dQ;

      dQ:= getQ(t-(T1+dT1-XCHGdT),1);
      EXP:=EXP + dQ;
      USER:= USER+dQ;
    end;
   end;
   dT1:= getDT(V1,ACC1);
   dT2:= getDT(V2,ACC2);



   if THW<(dT2+T2-XCHGdT) then begin
      dQ:= getQ(1,(dT2+T2-XCHGdT)-THW);
      ACC2:= ACC2-dQ;
      UACC2:= UACC2 + dQ;
      USER:=USER+dQ;
      THW:=dT2+T2-XCHGdT;
    end;

    if THW<(dT1+T1-XCHGdT) then begin
      dQ:= getQ(1,(dT1+T1-XCHGdT)-THW);
      ACC1:= ACC1-dQ;
      UACC1:= UACC1 + dQ;
      USER:=USER+dQ;
      THW:=dT1+T1-XCHGdT;
    end;