{ univerzalna :) command line }
unit inifile;

interface

type
  TshortStr=string[20];
  Tcmd=(_none,_day,_month,_hour,_geoWidth,_sklon,_azimut,_nadmVyska,
  _Z,_albedo,_SunConst,_cloudy,
      _LD,
      _ACC1,
      _ACC2,
      _USER,
      _LOST1,
      _LOST2,
      _COLOST,
      _UACC1,
      _UACC2,
      _TT1,
      _TT2,
      _T1,
      _dT1,
      _T2,
      _dT2,
      _V1,
      _V2,
      _TEQ,
      _CPDQM,
      _XCHGdT,
      _Ta,
      _S1,
      _iL1,
      _S2,
      _iL2,
      _ACCTempCond,
      _colar);


const
  maxBuf=2;

var
  xreal: array[0..3] of real;
  xint:  array[0..3] of longint;
  xstr:  array[0..3] of TshortStr;
  cmdCont: array[0..maxBuf] of TshortStr;
  c, oldc:Tcmd;
  cmdStr: string;

procedure cmd(cs:string);
procedure odmazMezirky(var instr: string);
procedure cutIt;

implementation


type
  Tpcmd=(none,OK);


var

  contInx: byte; {#paramstringu}
  pcmd: Tpcmd;
  err: integer;

procedure odmazMezirky(var instr: string);
begin
  while (instr[1]=#32) and (length(instr)>0) do {odmazani mezer....}
      delete(instr,1,1);
  delete(instr,pos(';',instr),length(instr)-pos(';',instr));

end;

procedure cutIt;
var
  i:byte;
begin
  cmdStr:= cmdStr + ' ';
  contInx:= 0;
  for i:=0 to 2 do
    cmdCont[i]:= '';
  while length(cmdStr)>0 do begin
    odmazMezirky(cmdStr);
    cmdCont[contInx]:=copy(cmdStr,1,pos(' ',cmdStr)-1);
    delete(cmdStr,1,pos(' ',cmdStr));
    inc(contInx);
  end;
end;

function cmdOK(nparam:byte):boolean;
var
  i:byte;
begin
  cmdOK:= true;
  for i:=0 to nparam-1 do
    if cmdCont[i]='' then begin
      cmdOK:= false;
      writeln('not enough actual parameters! try ''help''');
      break;
    end;
end;

procedure cmd(cs:string);
var
  i:byte;
begin
  {clear command buffers}
  for i:=0 to maxBuf do
    cmdCont[i]:='';

  cmdStr:= cs;
  cutIt;
  pcmd:=none;
  c:=_none;
  err:= 0;

  if (cmdCont[0] = 'day') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xint[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _day;
      end;
    end;
  end;

  if (cmdCont[0] = 'month') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xint[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _month;
      end;
    end;
  end;

  if (cmdCont[0] = 'hour') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _hour;
      end;
    end;
  end;

  if (cmdCont[0] = 'geoWidth') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xint[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _geoWidth;
      end;
    end;
  end;

  if (cmdCont[0] = 'sklon') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _sklon;
      end;
    end;
  end;

  if (cmdCont[0] = 'azimut') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _azimut;
      end;
    end;
  end;


  if (cmdCont[0] = 'nadmVyska') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _nadmVyska;
      end;
    end;
  end;

  if (cmdCont[0] = 'Z') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xint[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _Z;
      end;
    end;
  end;

  if (cmdCont[0] = 'albedo') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _albedo;
      end;
    end;
  end;

  if (cmdCont[0] = 'SunConst') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _SunConst;
      end;
    end;
  end;

  if (cmdCont[0] = 'cloudy') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xint[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _cloudy;
      end;
    end;
  end;
  if (cmdCont[0] = 'LD') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _LD;
      end;
    end;
  end;
  if (cmdCont[0] = 'ACC1') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _ACC1;
      end;
    end;
  end;
  if (cmdCont[0] = 'ACC2') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _ACC2;
      end;
    end;
  end;
  if (cmdCont[0] = 'USER') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _User;
      end;
    end;
  end;
  if (cmdCont[0] = 'LOST1') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _LOST1;
      end;
    end;
  end;
  if (cmdCont[0] = 'LOST2') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _LOST2;
      end;
    end;
  end;
  if (cmdCont[0] = 'COLOST') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _COLOST;
      end;
    end;
  end;
  if (cmdCont[0] = 'UACC1') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _UACC1;
      end;
    end;
  end;

  if (cmdCont[0] = 'UACC2') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _UACC2;
      end;
    end;
  end;

  if (cmdCont[0] = 'TT1') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _TT1;
      end;
    end;
  end;

  if (cmdCont[0] = 'TT2') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _TT2;
      end;
    end;
  end;

  if (cmdCont[0] = 'T1') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _T1;
      end;
    end;
  end;
  if (cmdCont[0] = 'T2') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _T2;
      end;
    end;
  end;

  if (cmdCont[0] = 'dT1') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _dT1;
      end;
    end;
  end;

  if (cmdCont[0] = 'dT2') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _dT2;
      end;
    end;
  end;

  if (cmdCont[0] = 'V1') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _V1;
      end;
    end;
  end;

  if (cmdCont[0] = 'V2') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _V2;
      end;
    end;
  end;

  if (cmdCont[0] = 'TEQ') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _TEQ;
      end;
    end;
  end;

  if (cmdCont[0] = 'CPDQM') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _CPDQM;
      end;
    end;
  end;

  if (cmdCont[0] = 'XCHGdT') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _XCHGdT;
      end;
    end;
  end;
  if (cmdCont[0] = 'Ta') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _Ta;
      end;
    end;
  end;

  if (cmdCont[0] = 'S1') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _S1;
      end;
    end;
  end;

  if (cmdCont[0] = 'S2') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _S2;
      end;
    end;
  end;

  if (cmdCont[0] = 'iL1') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _iL1;
      end;
    end;
  end;
  if (cmdCont[0] = 'iL2') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _iL2;
      end;
    end;
  end;

  if (cmdCont[0] = 'ACCTempCond') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _ACCTempCond;
      end;
    end;
  end;

  if (cmdCont[0] = 'colar') then begin
    if cmdOK(2) then begin
      val(cmdCont[1],xreal[0],err);
      if err=0 then begin
        pcmd:=OK;
        c:= _colar;
      end;
    end;
  end;


  if (pcmd=none) and (length(cmdCont[0])>0) then writeln('unknown parameter or error at:',err,' , try ''help''.');
  oldc:= c;
end;

end.